@echo off
:: COMPILE - batch file for compiling PBT scripts directly to an EXE file
:: (C) 2001-2003 PEERSOFT
::
:: If the PBT program file (PBT.EXE) is not in the current directory,
:: please set the PBT environment variable to point to your PBT directory.
:: Command example: SET PBT=C:\PBT\
::
if "%1"=="" goto help
if not exist %pbt%pbt.exe goto fatal
if not "%1"=="/p" goto parm1
shift
goto patchscript
:parm1
if not "%1"=="/P" goto parm2
shift
goto patchscript
:parm2
if not "%1"=="/s" goto parm3
shift
goto normscript
:parm3
if not "%1"=="/S" goto normsearch
shift
goto normscript
:normsearch
if not exist %1.scp goto nextsearch
if not exist %pbt%pp.exe goto fatal
%pbt%pp - %1.scp
if errorlevel 1 goto err1
%pbt%pbt lc %1 @$temp$.scr %2 %3 %4 %5 %6 %7 %8 %9
if errorlevel 1 goto err1
del $temp$.scr >nul
goto pbtmake
:nextsearch
if exist "%1.scr" goto normscript
if not exist "%1.pat" goto nofile
:patchscript
if "%2"=="" goto nodatafile
%pbt%pbt pm %1 %2 @%1.pat
if errorlevel 2 goto err1
if errorlevel 1 goto errlite
goto success
:normscript
%pbt%pbt lc %1 @%1.scr %2 %3 %4 %5 %6 %7 %8 %9
if errorlevel 1 goto err1
:pbtmake
%pbt%pbt lm %1 %1
if errorlevel 2 goto err1
if errorlevel 1 goto errlite
del %1.lcs >nul
:success
echo OK
goto end
:help
echo Compiles a script to an executable file.
echo Syntax: COMPILE [/S] File [additional commands]
echo         COMPILE [/P] File
echo File - name of a script file without an extension (SCP assumed)
echo If the *.SCP file was not found, *.SCR is searched.
echo If no *.SCR file was found, *.PAT is searched.
echo If you use the /S switch, compilation of the *.SCR file is assumed.
echo If you use the /P switch, compilation of the *.PAT file is assumed.
echo.
echo Example: COMPILE HEXDUMP - compiles HEXDUMP.SCP to HEXDUMP.EXE
echo          COMPILE /P CMOS ++CMOS.COM - compiles CMOS.PAT to CMOS.EXE
echo Notes:
echo - when compiling a patch, you must specify the file name to be
echo   patched as the second argument.
echo - When compiling PBT list scripts, you can specify additional script
echo   commands such as switches as arguments following the file name.
echo.
echo The PBT environment variable can point to a directory where PBT and PP
echo programs can be found. The directory name must end with a backslash
echo character. If no variable is defined, the current directory is assumed.
echo Example command: SET PBT=C:\UTIL\PBT\
goto end
:fatal
echo Fatal: PBT.EXE or PP.EXE not found
goto end
:nofile
echo Error: input file not found
goto end
:nodatafile
echo Error: no data file specified
goto end
:errlite
echo Error: you may have attempted to make executable files with PBT lite.
echo PBT lite has no abilities to make executable files, so please use
echo the full version of PBT.
goto end
:err1
echo Error while processing %1
:end
